<?php

class ControllerExtensionPaymentBspb extends Controller
{
    private $data = array();
    private $error = array();

    public function index()
    {
        $this->load->language('extension/payment/bspb');
        $this->document->setTitle($this->language->get('heading_title'));
        $this->load->model('setting/setting');

        $this->data = $this->request->post;
        if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
            $this->model_setting_setting->editSetting('payment_bspb', $this->data);
            $this->session->data['success'] = $this->language->get('text_success');
            $this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', 'SSL'));
        }

        if (isset($this->error['warning'])) {
            $data['error_warning'] = $this->error['warning'];
        } else {
            $data['error_warning'] = '';
        }

        if (isset($this->error['error_bspb_merchant'])) {
            $data['error_bspb_merchant'] = $this->error['error_bspb_merchant'];
        } else {
            $data['error_bspb_merchant'] = '';
        }
        if (isset($this->error['error_bspb_file_key'])) {
            $data['error_bspb_file_key'] = $this->error['error_bspb_file_key'];
        } else {
            $data['error_bspb_file_key'] = '';
        }
        if (isset($this->error['error_bspb_file_rem'])) {
            $data['error_bspb_file_rem'] = $this->error['error_bspb_file_rem'];
        } else {
            $data['error_bspb_file_rem'] = '';
        }
        if (isset($this->error['error_bspb_description'])) {
            $data['error_bspb_description'] = $this->error['error_bspb_description'];
        } else {
            $data['error_bspb_description'] = '';
        }

        $data['breadcrumbs'] = array(
            array(
                'text' => $this->language->get('text_home'),
                'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true),
            ),
            array(
                'text' => $this->language->get('text_payment'),
                'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true),
            ),
            array(
                'text' => $this->language->get('heading_title'),
                'href' => $this->url->link('extension/payment/bspb', 'user_token=' . $this->session->data['user_token'], true),
            ),
        );
        $data['action'] = $this->url->link('extension/payment/bspb', 'user_token=' . $this->session->data['user_token'], 'SSL');
        $data['cancel'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'], 'SSL');

        $data['bspb_txt_settings'] = $this->language->get('bspb_txt_settings');


        $data['bspb_txt_mode'] = $this->language->get('bspb_txt_mode');
        $data['bspb_txt_mode_test'] = $this->language->get('bspb_txt_mode_test');
        $data['bspb_txt_mode_prod'] = $this->language->get('bspb_txt_mode_prod');
        if (isset($this->request->post['payment_bspb_mode'])) {
            $data['payment_bspb_mode'] = $this->request->post['payment_bspb_mode'];
        } else {
            $data['payment_bspb_mode'] = $this->config->get('payment_bspb_mode');
        }

        $data['bspb_txt_merchant'] = $this->language->get('bspb_txt_merchant');
        if (isset($this->request->post['payment_bspb_merchant'])) {
            $data['payment_bspb_merchant'] = $this->request->post['payment_bspb_merchant'];
        } else {
            $data['payment_bspb_merchant'] = $this->config->get('payment_bspb_merchant');
        }

        $data['bspb_txt_file_key'] = $this->language->get('bspb_txt_file_key');
        if (isset($this->request->post['payment_bspb_file_key'])) {
            $data['payment_bspb_file_key'] = $this->request->post['payment_bspb_file_key'];
            $data['payment_bspb_file_key_short'] = $this->request->post['payment_bspb_file_key_short'];
        } else {
            $data['payment_bspb_file_key'] = $this->config->get('payment_bspb_file_key');
            $data['payment_bspb_file_key_short'] = $this->config->get('payment_bspb_file_key_short');
        }

        $data['bspb_txt_file_rem'] = $this->language->get('bspb_txt_file_rem');
        if (isset($this->request->post['payment_bspb_file_rem'])) {
            $data['payment_bspb_file_rem'] = $this->request->post['payment_bspb_file_rem'];
            $data['payment_bspb_file_rem_short'] = $this->request->post['payment_bspb_file_rem_short'];
        } else {
            $data['payment_bspb_file_rem'] = $this->config->get('payment_bspb_file_rem');
            $data['payment_bspb_file_rem_short'] = $this->config->get('payment_bspb_file_rem_short');
        }

        $data['bspb_txt_description'] = $this->language->get('bspb_txt_description');
        if (isset($this->request->post['payment_bspb_description'])) {
            $data['payment_bspb_description'] = $this->request->post['payment_bspb_description'];
        } else {
            $data['payment_bspb_description'] = $this->config->get('payment_bspb_description');
        }

        $data['bspb_txt_order_type'] = $this->language->get('bspb_txt_order_type');
        if (isset($this->request->post['payment_bspb_order_type'])) {
            $data['payment_bspb_order_type'] = $this->request->post['payment_bspb_order_type'];
        } else {
            $data['payment_bspb_order_type'] = $this->config->get('payment_bspb_order_type');
        }

        $data['bspb_txt_currency'] = $this->language->get('bspb_txt_currency');
        $data['bspb_txt_currency_rub'] = $this->language->get('bspb_txt_currency_rub');
        if (isset($this->request->post['payment_bspb_currency'])) {
            $data['payment_bspb_currency'] = $this->request->post['payment_bspb_currency'];
        } else {
            $data['payment_bspb_currency'] = $this->config->get('payment_bspb_currency');
        }

        $data['bspb_txt_language'] = $this->language->get('bspb_txt_language');
        $data['bspb_txt_language_ru'] = $this->language->get('bspb_txt_language_ru');
        $data['bspb_txt_language_en'] = $this->language->get('bspb_txt_language_en');
        if (isset($this->request->post['payment_bspb_language'])) {
            $data['payment_bspb_language'] = $this->request->post['payment_bspb_language'];
        } else {
            $data['payment_bspb_language'] = $this->config->get('payment_bspb_language');
        }


        $data['bspb_txt_order_status'] = $this->language->get('bspb_txt_order_status');
        if (isset($this->request->post['payment_bspb_order_status_id'])) {
            $data['payment_bspb_order_status_id'] = $this->request->post['payment_bspb_order_status_id'];
        } else {
            $data['payment_bspb_order_status_id'] = $this->config->get('payment_bspb_order_status_id');
        }
        $this->load->model('localisation/order_status');
        $data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();

        $data['bspb_txt_geo_zone'] = $this->language->get('bspb_txt_geo_zone');
        if (isset($this->request->post['payment_bspb_geo_zone_id'])) {
            $data['payment_bspb_geo_zone_id'] = $this->request->post['payment_bspb_geo_zone_id'];
        } else {
            $data['payment_bspb_geo_zone_id'] = $this->config->get('payment_bspb_geo_zone_id');
        }
        $this->load->model('localisation/geo_zone');
        $data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();

        $data['bspb_txt_status'] = $this->language->get('bspb_txt_status');
        if (isset($this->request->post['payment_bspb_status'])) {
            $data['payment_bspb_status'] = $this->request->post['payment_bspb_status'];
        } else {
            $data['payment_bspb_status'] = $this->config->get('payment_bspb_status');
        }

        $data['bspb_txt_sort_order'] = $this->language->get('bspb_txt_sort_order');
        if (isset($this->request->post['payment_bspb_sort_order'])) {
            $data['payment_bspb_sort_order'] = $this->request->post['payment_bspb_sort_order'];
        } else {
            $data['payment_bspb_sort_order'] = $this->config->get('payment_bspb_sort_order');
        }

        $data['header'] = $this->load->controller('common/header');
        $data['column_left'] = $this->load->controller('common/column_left');
        $data['footer'] = $this->load->controller('common/footer');

        $this->response->setOutput($this->load->view('extension/payment/bspb', $data));
    }

    private function validate()
    {
        if (!$this->user->hasPermission('modify', 'extension/payment/bspb')) {
            $this->error['warning'] = $this->language->get('error_permission');
        }

        if (!$this->request->post['payment_bspb_merchant']) {
            $this->error['error_bspb_merchant'] = $this->language->get('error_bspb_required');
        }

        if (array_key_exists('payment_bspb_file_key_new', $_FILES)
            && array_key_exists('tmp_name', $_FILES['payment_bspb_file_key_new'])
            && array_key_exists('size', $_FILES['payment_bspb_file_key_new'])
            && $_FILES['payment_bspb_file_key_new']['size'] > 0) 
        {
            $fileKey = substr(md5(time()), 0, 16) . '.key';
            move_uploaded_file($_FILES['payment_bspb_file_key_new']['tmp_name'], __DIR__ . '/' . $fileKey);
            unlink($_FILES['payment_bspb_file_key_new']['tmp_name']);
            $this->data['payment_bspb_file_key'] = __DIR__ . '/' . $fileKey;
            $this->data['payment_bspb_file_key_short'] = $fileKey;
        } elseif (!$this->request->post['payment_bspb_file_key']) {
            $this->error['payment_bspb_file_key'] = $this->language->get('error_bspb_required');
        }

        if (array_key_exists('payment_bspb_file_rem_new', $_FILES)
            && array_key_exists('tmp_name', $_FILES['payment_bspb_file_rem_new'])
            && array_key_exists('size', $_FILES['payment_bspb_file_rem_new'])
            && $_FILES['payment_bspb_file_rem_new']['size'] > 0) 
        {
            $filePem = substr(md5(time()), 0, 16) . '.pem';
            move_uploaded_file($_FILES['payment_bspb_file_rem_new']['tmp_name'], __DIR__ . '/' . $filePem);
            unlink($_FILES['payment_bspb_file_rem_new']['tmp_name']);
            $this->data['payment_bspb_file_rem'] = __DIR__ . '/' . $filePem;
            $this->data['payment_bspb_file_rem_short'] = $filePem;
        } elseif (!$this->request->post['payment_bspb_file_rem']) {
            $this->error['error_bspb_file_rem'] = $this->language->get('error_bspb_required');
        }

        if (!$this->request->post['payment_bspb_description']) {
            $this->error['error_bspb_description'] = $this->language->get('error_bspb_required');
        }

        return !$this->error;
    }
}
